@echo off

IF /i "%1"=="-clean" GOTO clean

set opt1="-auto-level -gamma 0.94 -unsharp 0 -ordered-dither o2x2"
set opt2="-ordered-dither o4x4"
set opt3="-auto-level -dither FloydSteinberg"
set opt4="-auto-level -gamma 0.94 -ordered-dither o4x4"
set opt5="-auto-level -gamma 0.45 -unsharp 0 -ordered-dither o4x4"
set opt6="-auto-level -gamma 0.95 -unsharp 0 -ordered-dither o4x4"

mkdir gbpic
mkdir picout
IF EXIST dat\LEAF.LFG (ren dat\LEAF.LFG LEAFG.LFG)
for %%n in (dat\c0???.lf2 dat\c1???.lf2 dat\leaf.lf2 dat\leafg.lfg) do call :proc_chr %%n %opt1%
for %%n in (dat\c1c01.lf2) do call :proc_chr %%n %opt3%
for %%n in (dat\h*.lf2 dat\s*.lf2 dat\v*.lf2) do call :proc_bg %%n %opt3%
for %%n in (dat\oc_*.lf2 dat\title2.lf2) do call :proc_chr %%n %opt1%

call :proc_bg dat\cbak.lf2 %opt4%
call :proc_chrsp dat\cbak_00.lf2 192 80 %opt5%
call :proc_chrsp dat\cbak_01.lf2 192 80 %opt5%
call :proc_chrsp dat\cbak_02.lf2 192 80 %opt5%
call :proc_chrsp dat\cbak_03.lf2 192 56 %opt5%
call :proc_chrsp dat\cbak_04.lf2 192 24 %opt5%
call :proc_chrsp dat\cbak_05.lf2 192 24 %opt5%
call :proc_chrsp dat\cbak_06.lf2 440 24 %opt5%
call :proc_chrsp dat\cbak_07.lf2 584 24 %opt5%
for %%n in (dat\cmon_*.lf2) do call :proc_chrsp %%n 200 88 %opt6%
for %%n in (dat\cweek_*.lf2) do call :proc_chrsp %%n 280 344 %opt6%
for %%n in (dat\clno_*.lf2) do call :proc_chrsp %%n 264 196 %opt6%
for %%n in (dat\csno_*.lf2) do call :proc_chrsp %%n 232 196 %opt6%
for %%n in (dat\op??.lf2) do call :proc_chrsp %%n 120 90 %opt1%

for %%n in (gbpic\*.BIN) do %LZ4% -9 %%n picout\%%~nn.LZ4
%GBFILE% -m0 -b75 -s1 picout
%GBFILE% -mergefat picout_fat.bin
move /Y picout_fat.bin picfat.bin
%BINPASTE% picout.bin -aj 1474560 0xFF
goto :eof

rem ł

rem =================================================================
rem // LF2 -> }XNtL摜
rem =================================================================
:proc_chr
%TH256DEC% %1 chr 2
%TH256DEC% %1 chr -m
%MAGIC% chr\%~n1.png -resize 25%%x30%% %~2 -remap %CMAP% png24:chr\%~n1_m.png
%TH256DEC% chr\%~n1_m.png chr -t %1
copy /b chr\%~n1.hed+chr\%~n1.msk+chr\%~n1_m.gbt gbpic\%~n1.bin
exit /B 1

rem =================================================================
rem // LF2 -> }XNtL摜iʁj
rem =================================================================
:proc_chrsp
%TH256DEC% %1 chr 2 -o%2,%3
%TH256DEC% %1 chr -m -o%2,%3
%MAGIC% chr\%~n1.png -resize 25%%x30%% %~4 -remap %CMAP% png24:chr\%~n1_m.png
%TH256DEC% chr\%~n1_m.png chr -t %1 -o%2,%3
copy /b chr\%~n1.hed+chr\%~n1.msk+chr\%~n1_m.gbt gbpic\%~n1.bin
exit /B 1

rem =================================================================
rem // LF2 -> wiErWAV[摜
rem =================================================================
:proc_bg
%TH256DEC% %1 bg 0
%MAGIC% bg\%~n1.png -resize 25%%x30%% %~2 -remap %CMAP% png24:bg\%~n1_m.png
%TH256DEC% bg\%~n1_m.png bg -t %1
copy /b bg\%~n1.hed+bg\%~n1_m.gbt gbpic\%~n1.BIN
exit /B 1

rem =================================================================
rem // |
rem =================================================================
:clean
del bg\*.*
del chr\*.*
del gbpic\*.*
del picout\*.*
goto :eof
